#include <stdio.h>
#include <termios.h>
#include <unistd.h>
#include <sys/select.h>
#include<cstdio>
#include "rect.h"
#include "ezwin.h"
#include <cassert>

#include "position.h"
#include <stdlib.h>
#include <time.h>

// Create a window with title "Basic", size 10cm x 10cm,
//     positioned 3cm from left, 1cm from top of screen.
SimpleWindow MyWindow("Snake", 10.0, 10.0,
	      Position(3.0, 1.0));


// Macros
#define LEFT 1
#define RIGHT 2
#define UP 3
#define DOWN 4

//Game Data

int score; //Keeps the count of game score
int gamedelay;//Lower the game delay faster is the game speed.

struct Snake_Data {

int Length;
float x[1000];// Stores Head X Coordinate
float y[1000]; // Stores Head Y Coordinate
float head_dir; // Stores Head Direction
} Snake; // Declares a variable of the structure

// User - Defined functions -

void userinput ()// This Function changes the direction of motion of snake according to input.
{
  static int i = 0;
  if ( i > 1000) i = 0; // Makes the bend array a circular queue
  static int j = 0;
  if ( j > 1000) j = 0;
  char input;
    
   srand ( time(NULL) );

  /* generate secret number: */
  input = rand() % 4 + 1;
    
    //Change Respective Return value to our MACRO Direction Code Value 
               
     if (input == 4) input = DOWN;
               
     if (input == 3) input = UP;
               
     if (input == 1) input = LEFT;
               
     if (input == 2) input = RIGHT;

   //Change head direction based on logic
               
     if (input == LEFT && Snake.head_dir != RIGHT && Snake.head_dir != LEFT)
        {
          Snake.head_dir = LEFT; 
        } 
     if (input == RIGHT && Snake.head_dir != LEFT && Snake.head_dir != RIGHT)
        {
          Snake.head_dir = RIGHT;
          
         }
     if (input == UP && Snake.head_dir != DOWN && Snake.head_dir != UP)
        {
          Snake.head_dir = UP;
         
        }
    if (input == DOWN && Snake.head_dir != UP && Snake.head_dir != DOWN)
        {
          Snake.head_dir = DOWN;
         }

     }
       

void movesnake ()
 {
  //Move the Head
  if (Snake.head_dir == LEFT)
     {
        Snake.x[0] -=.2; 
     }
  if (Snake.head_dir == RIGHT) 
     {
        Snake.x[0] +=.2; 
     }
  if (Snake.head_dir == UP) 
     {
       Snake.y[0] -=.2;
     }
  if (Snake.head_dir == DOWN) 
     {
       Snake.y[0] +=.2;
     } 
     for(int i=Snake.Length-1;i>0;i--)
     {
     	Snake.x[i]=Snake.x[i-1];
     	Snake.y[i]=Snake.y[i-1];
     }
     MyWindow.RenderRectangle(Position(0,0),Position(10,10),White,false);
	for(int i=0;i<Snake.Length;i++)
	{
		RectangleShape  New(MyWindow,Snake.x[i], Snake.y[i],Red,.2,.2);
		New.Draw();
	}

}
            

void gameengine ()//Soul of our game.
 {
   while (1) 
     {
       
       movesnake ();
       for(int i=0;i<100000;i++)
       userinput ();	
     }
  }
 


void initgamedata ( ) //Snakes starting coordinate if you modify any one make sure also modify dependent values
 {
   int i;
   Snake.Length = 10;
   Snake.x[0] = 6.0;
   Snake.y[0] = 5.0;
   Snake.head_dir = RIGHT;
    score = 0;
    gamedelay = 1000; // Should be change according to game speed need. 
   for(int c=0;c<Snake.Length;c++)
   {
   	Snake.x[c]=6.0-.2*c;
   	Snake.y[c]=5.0;
   	RectangleShape R1(MyWindow,Snake.x[c],Snake.y[c],Red,.2,.2);
   	R1.Draw();
   }
}



// Main Function

int ApiMain ()

{
   MyWindow.Open();
   initgamedata ();
   gameengine (); 
   return 0;
}